xref: /linux/scripts/kconfig/Makefile (revision 312ee68752faaa553499775d2c191ff7a883826f)
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
7	localmodconfig localyesconfig
8
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
12Kconfig := Kconfig
13endif
14
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
22xconfig: $(obj)/qconf
23	$< $(silent) $(Kconfig)
24
25gconfig: $(obj)/gconf
26	$< $(silent) $(Kconfig)
27
28menuconfig: $(obj)/mconf
29	$< $(silent) $(Kconfig)
30
31config: $(obj)/conf
32	$< $(silent) --oldaskconfig $(Kconfig)
33
34nconfig: $(obj)/nconf
35	$< $(silent) $(Kconfig)
36
37silentoldconfig: $(obj)/conf
38	$(Q)mkdir -p include/config include/generated
39	$(Q)test -e include/generated/autoksyms.h || \
40	    touch   include/generated/autoksyms.h
41	$< $(silent) --$@ $(Kconfig)
42
43localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
44	$(Q)mkdir -p include/config include/generated
45	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
46	$(Q)if [ -f .config ]; then 					\
47			cmp -s .tmp.config .config ||			\
48			(mv -f .config .config.old.1;			\
49			 mv -f .tmp.config .config;			\
50			 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
51			 mv -f .config.old.1 .config.old)		\
52	else								\
53			mv -f .tmp.config .config;			\
54			$(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
55	fi
56	$(Q)rm -f .tmp.config
57
58# Create new linux.pot file
59# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
60update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
61	$(Q)$(kecho) "  GEN     config.pot"
62	$(Q)xgettext --default-domain=linux                         \
63	    --add-comments --keyword=_ --keyword=N_                 \
64	    --from-code=UTF-8                                       \
65	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
66	    --directory=$(srctree) --directory=$(objtree)           \
67	    --output $(obj)/config.pot
68	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
69	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
70	    $(srctree)/arch/*/um/Kconfig`;               \
71	    do                                           \
72		$(kecho) "  GEN     $$i";                    \
73		$(obj)/kxgettext $$i                     \
74		     >> $(obj)/config.pot;               \
75	    done )
76	$(Q)$(kecho) "  GEN     linux.pot"
77	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
78	    --output $(obj)/linux.pot
79	$(Q)rm -f $(obj)/config.pot
80
81# These targets map 1:1 to the commandline options of 'conf'
82simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
83	alldefconfig randconfig listnewconfig olddefconfig
84PHONY += $(simple-targets)
85
86$(simple-targets): $(obj)/conf
87	$< $(silent) --$@ $(Kconfig)
88
89PHONY += oldnoconfig savedefconfig defconfig
90
91# oldnoconfig is an alias of olddefconfig, because people already are dependent
92# on its behavior (sets new symbols to their default value but not 'n') with the
93# counter-intuitive name.
94oldnoconfig: olddefconfig
95	@echo "  WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
96	@echo "            Please use \"olddefconfig\" instead, which is an alias."
97
98savedefconfig: $(obj)/conf
99	$< $(silent) --$@=defconfig $(Kconfig)
100
101defconfig: $(obj)/conf
102ifeq ($(KBUILD_DEFCONFIG),)
103	$< $(silent) --defconfig $(Kconfig)
104else
105ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
106	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
107	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
108else
109	@$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
110	$(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
111endif
112endif
113
114%_defconfig: $(obj)/conf
115	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
116
117configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
118
119%.config: $(obj)/conf
120	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
121	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
122	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
123
124PHONY += kvmconfig
125kvmconfig: kvm_guest.config
126	@:
127
128PHONY += xenconfig
129xenconfig: xen.config
130	@:
131
132PHONY += tinyconfig
133tinyconfig:
134	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
135
136# Help text used by make help
137help:
138	@echo  '  config	  - Update current config utilising a line-oriented program'
139	@echo  '  nconfig         - Update current config utilising a ncurses menu based'
140	@echo  '                    program'
141	@echo  '  menuconfig	  - Update current config utilising a menu based program'
142	@echo  '  xconfig	  - Update current config utilising a Qt based front-end'
143	@echo  '  gconfig	  - Update current config utilising a GTK+ based front-end'
144	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
145	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
146	@echo  '  localyesconfig  - Update current config converting local mods to core'
147	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
148	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
149	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
150	@echo  '  allnoconfig	  - New config where all options are answered with no'
151	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
152	@echo  '  allmodconfig	  - New config selecting modules when possible'
153	@echo  '  alldefconfig    - New config with all symbols set to default'
154	@echo  '  randconfig	  - New config with random answer to all options'
155	@echo  '  listnewconfig   - List new options'
156	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their'
157	@echo  '                    default value'
158	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
159	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
160	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
161
162# lxdialog stuff
163check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
164
165# Use recursively expanded variables so we do not call gcc unless
166# we really need to do so. (Do not call gcc as part of make mrproper)
167HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
168                    -DLOCALE
169
170# ===========================================================================
171# Shared Makefile for the various kconfig executables:
172# conf:	  Used for defconfig, oldconfig and related targets
173# nconf:  Used for the nconfig target.
174#         Utilizes ncurses
175# mconf:  Used for the menuconfig target
176#         Utilizes the lxdialog package
177# qconf:  Used for the xconfig target
178#         Based on Qt which needs to be installed to compile it
179# gconf:  Used for the gconfig target
180#         Based on GTK+ which needs to be installed to compile it
181# object files used by all kconfig flavours
182
183lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
184lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
185
186conf-objs	:= conf.o  zconf.tab.o
187mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
188nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
189kxgettext-objs	:= kxgettext.o zconf.tab.o
190qconf-cxxobjs	:= qconf.o
191qconf-objs	:= zconf.tab.o
192gconf-objs	:= gconf.o zconf.tab.o
193
194hostprogs-y := conf nconf mconf kxgettext qconf gconf
195
196targets		+= zconf.tab.c zconf.lex.c
197clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
198clean-files	+= zconf.tab.c zconf.lex.c gconf.glade.h
199clean-files     += config.pot linux.pot
200
201# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
202PHONY += $(obj)/dochecklxdialog
203$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
204$(obj)/dochecklxdialog:
205	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
206
207always := dochecklxdialog
208
209# Add environment specific flags
210HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
211HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
212
213# generated files seem to need this to find local include files
214HOSTCFLAGS_zconf.lex.o	:= -I$(src)
215HOSTCFLAGS_zconf.tab.o	:= -I$(src)
216
217HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
218HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
219
220HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
221HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
222                          -Wno-missing-prototypes
223
224HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
225
226HOSTLOADLIBES_nconf	= $(shell \
227				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
228				|| pkg-config --libs menu panel ncurses 2>/dev/null \
229				|| echo "-lmenu -lpanel -lncurses"  )
230$(obj)/qconf.o: $(obj)/.tmp_qtcheck
231
232ifeq ($(MAKECMDGOALS),xconfig)
233$(obj)/.tmp_qtcheck: $(src)/Makefile
234-include $(obj)/.tmp_qtcheck
235
236# Qt needs some extra effort...
237$(obj)/.tmp_qtcheck:
238	@set -e; $(kecho) "  CHECK   qt"; \
239	if pkg-config --exists Qt5Core; then \
240	    cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
241	    libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
242	    moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
243	elif pkg-config --exists QtCore; then \
244	    cflags=`pkg-config --cflags QtCore QtGui`; \
245	    libs=`pkg-config --libs QtCore QtGui`; \
246	    moc=`pkg-config --variable=moc_location QtCore`; \
247	else \
248	    echo >&2 "*"; \
249	    echo >&2 "* Could not find Qt via pkg-config."; \
250	    echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
251	    echo >&2 "*"; \
252	    exit 1; \
253	fi; \
254	echo "KC_QT_CFLAGS=$$cflags" > $@; \
255	echo "KC_QT_LIBS=$$libs" >> $@; \
256	echo "KC_QT_MOC=$$moc" >> $@
257endif
258
259$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
260
261ifeq ($(MAKECMDGOALS),gconfig)
262-include $(obj)/.tmp_gtkcheck
263
264# GTK+ needs some extra effort, too...
265$(obj)/.tmp_gtkcheck:
266	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
267		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
268			touch $@;								\
269		else									\
270			echo >&2 "*"; 							\
271			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
272			echo >&2 "*";							\
273			false;								\
274		fi									\
275	else										\
276		echo >&2 "*"; 								\
277		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
278		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
279		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
280		echo >&2 "*"; 								\
281		false;									\
282	fi
283endif
284
285$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
286
287$(obj)/qconf.o: $(obj)/qconf.moc
288
289quiet_cmd_moc = MOC     $@
290      cmd_moc = $(KC_QT_MOC) -i $< -o $@
291
292$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
293	$(call cmd,moc)
294
295# Extract gconf menu items for i18n support
296$(obj)/gconf.glade.h: $(obj)/gconf.glade
297	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
298	$(obj)/gconf.glade
299